## xrt 2.21.70

=== CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2025 Advanced Micro Devices, Inc. All rights reserved.
cmake_minimum_required(VERSION 3.16.0)
project(XRT-UPSTREAM)

set(XRT_BUILD_NUMBER 70)
set(XRT_UPSTREAM_DEBIAN 1)
set(XRT_UPSTREAM 1)

add_subdirectory(xrt)
add_subdirectory(xdna)

=== xdna/xdna-driver/src/driver/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022-2025, Advanced Micro Devices, Inc. All rights reserved.

set(XDNA_DRV amdxdna)

set(XDNA_DRV_DIR amdxdna)
set(XDNA_DRV_TGT ${XDNA_DRV}.ko)
set(XDNA_DRV_PATH ${CMAKE_BINARY_DIR}/driver/${XDNA_DRV_TGT})
set(XDNA_DRV_BLD_DIR driver/${XDNA_DRV_DIR})
set(XDNA_DRV_BLD_SRC ${CMAKE_CURRENT_BINARY_DIR}/${XDNA_DRV_BLD_DIR})
set(XDNA_DRV_BLD_TGT ${CMAKE_CURRENT_BINARY_DIR}/${XDNA_DRV_DIR})

set(XDNA_DRV_PF amdxdna_pf)

set(XDNA_DRV_PF_DIR amdxdna_pf)
set(XDNA_DRV_PF_TGT ${XDNA_DRV_PF}.ko)
set(XDNA_DRV_PF_PATH ${CMAKE_BINARY_DIR}/driver/${XDNA_DRV_PF_TGT})
set(XDNA_DRV_PF_BLD_DIR driver/${XDNA_DRV_PF_DIR})
set(XDNA_DRV_PF_BLD_SRC ${CMAKE_CURRENT_BINARY_DIR}/${XDNA_DRV_PF_BLD_DIR})
set(XDNA_DRV_PF_BLD_TGT ${CMAKE_CURRENT_BINARY_DIR}/${XDNA_DRV_PF_DIR})

# Common flags used for both building driver and configuring dkms
if (DEFINED ENV{XDNA_DRV_BLD_FLAGS})
  set(XDNA_DRV_BLD_FLAGS_DKMS $ENV{XDNA_DRV_BLD_FLAGS})
  set(XDNA_DRV_BLD_FLAGS_MAKE $ENV{XDNA_DRV_BLD_FLAGS})
  separate_arguments(XDNA_DRV_BLD_FLAGS_MAKE)
endif(DEFINED ENV{XDNA_DRV_BLD_FLAGS})

message("-- Extra driver source dir: ${XDNA_EXTRA_DRV_DIR}")
message("-- Extra driver tar exclude rules: ${XDNA_EXTRA_DRV_EXCLUDES}")

add_custom_command(
  OUTPUT all_driver_source
  COMMENT "Collect all driver source code"
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $(CMAKE_COMMAND) -E make_directory ${XDNA_DRV_BLD_DIR}
  COMMAND cp -rf ${CMAKE_CURRENT_SOURCE_DIR}/${XDNA_DRV_DIR}/* ${XDNA_EXTRA_DRV_DIR} ${XDNA_DRV_BLD_DIR}
  COMMAND cp -r ${CMAKE_CURRENT_SOURCE_DIR}/../include .
  COMMAND cp -r ${CMAKE_CURRENT_SOURCE_DIR}/tools/configure_kernel.sh .
  )

# Generate config_kernel.h before doing build
add_custom_command(
  OUTPUT ${XDNA_DRV_BLD_SRC}/configure_kernel.h
  COMMENT "Configuring kernel compatibility header"
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E env bash ./configure_kernel.sh
  DEPENDS all_driver_source
)

# Because ${XDNA_DRV_TGT} is generated in ${XDNA_DRV_BLD_TGT}. So this custom command will always run.
add_custom_command(
  OUTPUT ${XDNA_DRV_TGT}
  COMMENT "Build ${XDNA_DRV_TGT}"
  COMMAND $(MAKE) -f ${XDNA_DRV_BLD_SRC}/Makefile BUILD_ROOT_DIR=${XDNA_DRV_BLD_TGT} ${KERNEL_VER} UMQ_HELLO_TEST=${UMQ_HELLO_TEST} ${XDNA_DRV_BLD_FLAGS_MAKE} XDNA_BUS_TYPE=pci
  COMMAND $(MAKE) -f ${XDNA_DRV_BLD_SRC}/Makefile BUILD_ROOT_DIR=${XDNA_DRV_BLD_TGT} copy_ko
  COMMAND $(CMAKE_COMMAND) -E copy ${XDNA_DRV_BLD_TGT}/${XDNA_DRV_TGT} ${XDNA_DRV_PATH}
  DEPENDS ${XDNA_DRV_BLD_SRC}/configure_kernel.h
  )

add_custom_command(
  OUTPUT pf_driver_source
  COMMENT "Collect pf driver source code"
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND $(CMAKE_COMMAND) -E make_directory ${XDNA_DRV_PF_BLD_DIR}
  COMMAND cp -rf ${XDNA_DRV_PF_SRC_DIR} ${XDNA_DRV_PF_BLD_DIR}
  #temporary workaround to grab common code for pf driver
  COMMAND cp ${XDNA_DRV_BLD_DIR}/amdxdna_mailbox.* ${XDNA_DRV_BLD_DIR}/amdxdna_trace.h ${XDNA_DRV_BLD_DIR}/aie4/aie4_msg_priv.h ${XDNA_DRV_PF_BLD_DIR}
  DEPENDS all_driver_source
)

# Build amdxdna_pf driver
add_custom_command(
  OUTPUT ${XDNA_DRV_PF_TGT}
  COMMENT "Build ${XDNA_DRV_PF_TGT}"
  COMMAND $(MAKE) -f ${XDNA_DRV_PF_BLD_SRC}/Makefile BUILD_ROOT_DIR=${XDNA_DRV_PF_BLD_TGT} ${KERNEL_VER} XDNA_BUS_TYPE=pci
  COMMAND $(MAKE) -f ${XDNA_DRV_PF_BLD_SRC}/Makefile BUILD_ROOT_DIR=${XDNA_DRV_PF_BLD_TGT} copy_ko
  COMMAND $(CMAKE_COMMAND) -E copy ${XDNA_DRV_PF_BLD_TGT}/${XDNA_DRV_PF_TGT} ${XDNA_DRV_PF_PATH}
  DEPENDS ${XDNA_DRV_BLD_SRC}/configure_kernel.h pf_driver_source
  )

if(XDNA_DRV_PF_SRC_DIR)
add_custom_target(driver ALL DEPENDS ${XDNA_DRV_TGT} ${XDNA_DRV_PF_TGT})
else()
add_custom_target(driver ALL DEPENDS ${XDNA_DRV_TGT})
endif()

# Tar and install driver source code for packaging
set(XDNA_DRV_SRC_DIR
  driver
  include
  )
set(XDNA_DRV_EXCLUDES
  --exclude=CMake*
  --exclude=tools
  --exclude=doc
  ${XDNA_EXTRA_DRV_EXCLUDES}
  )
file(GLOB_RECURSE ALL_DRV_FILES
  ${XDNA_DRV_BLD_SRC}/Makefile
  ${XDNA_DRV_BLD_SRC}/*.c
  ${XDNA_DRV_BLD_SRC}/*.h
  ${CMAKE_CURRENT_BINARY_DIR}/include/*.h
  )
set(XDNA_DRV_SRC_TGT ${XDNA_DRV}.tar)
add_custom_command(
  OUTPUT ${CMAKE_BINARY_DIR}/driver/${XDNA_DRV_SRC_TGT}
  COMMENT "Tar ${XDNA_DRV} driver source code"
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND tar ${XDNA_DRV_EXCLUDES} -cf ${CMAKE_CURRENT_BINARY_DIR}/${XDNA_DRV_SRC_TGT} ${XDNA_DRV_SRC_DIR}
  COMMAND $(CMAKE_COMMAND) -E copy ${CMAKE_CURRENT_BINARY_DIR}/${XDNA_DRV_SRC_TGT} ${CMAKE_BINARY_DIR}/driver/${XDNA_DRV_SRC_TGT}
  DEPENDS ${ALL_DRV_FILES}
  )

# Substitute driver version in the source code
set(XDNA_TAR_GZ ${XDNA_DRV}.tar.gz)
add_custom_command(
  OUTPUT ${CMAKE_BINARY_DIR}/driver/${XDNA_TAR_GZ}
  COMMENT "Substitute amdxdna module version and re-tar"
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/driver
  COMMAND $(CMAKE_COMMAND) -E make_directory tmp
  COMMAND tar xf ${CMAKE_BINARY_DIR}/driver/${XDNA_DRV_SRC_TGT} -C tmp
  COMMAND find tmp -name amdxdna_pci_drv.c -exec sed -i 's/MODULE_VERSION\(\".*\"\)/MODULE_VERSION\(\"${XRT_PLUGIN_VERSION_STRING}_${XDNA_DATE},${XDNA_HASH}\"\)/' {} \\\;
  COMMAND tar zcf ${CMAKE_BINARY_DIR}/driver/${XDNA_TAR_GZ} -C tmp .
  COMMAND $(CMAKE_COMMAND) -E rm -r tmp
  DEPENDS ${CMAKE_BINARY_DIR}/driver/${XDNA_DRV_SRC_TGT}
  )
add_custom_target(driver_ver_tarball ALL DEPENDS ${CMAKE_BINARY_DIR}/driver/${XDNA_TAR_GZ} driver)
install(FILES ${CMAKE_BINARY_DIR}/driver/${XDNA_TAR_GZ}
  DESTINATION ${XDNA_PKG_DATA_DIR}
  COMPONENT ${XDNA_COMPONENT}
  )

set(MAKE_DRV "cd driver/${XDNA_DRV_DIR}; make ${XDNA_DRV_BLD_FLAGS_DKMS} KERNEL_SRC=\${kernel_source_dir}; cd ../..")
set(CLEAN_DRV "cd driver/${XDNA_DRV_DIR}; make clean KERNEL_SRC=\${kernel_source_dir}; cd ../..")
set(MODULE_DRV "BUILT_MODULE_NAME[0]=${XDNA_DRV}
BUILT_MODULE_LOCATION[0]=\"driver/${XDNA_DRV_DIR}/build/driver/amdxdna\"
DEST_MODULE_LOCATION[0]=\"/kernel/extras\"")

if(XDNA_DRV_PF_SRC_DIR)
  set(MAKE_DRV "${MAKE_DRV}; cd driver/${XDNA_DRV_PF_DIR}; make KERNEL_SRC=\${kernel_source_dir}; cd ../..")
  set(CLEAN_DRV "${CLEAN_DRV}; cd driver/${XDNA_DRV_PF_DIR}; make clean KERNEL_SRC=\${kernel_source_dir}; cd ../..")
  set(MODULE_DRV "${MODULE_DRV}
BUILT_MODULE_NAME[1]=${XDNA_DRV_PF}
BUILT_MODULE_LOCATION[1]=\"driver/${XDNA_DRV_PF_DIR}/build/driver/amdxdna_pf\"
DEST_MODULE_LOCATION[1]=\"/kernel/extras\"")
endif(XDNA_DRV_PF_SRC_DIR)

# Install config file and driver related scripts for packaging
set(XDNA_DKMS_PKG_NAME xrt-${XDNA_DRV})
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/CMake/config/dkms.conf.in
  ${CMAKE_CURRENT_BINARY_DIR}/dkms.conf
  @ONLY
  )
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dkms.conf
  DESTINATION ${XDNA_PKG_DATA_DIR}
  COMPONENT ${XDNA_COMPONENT}
  )

# install .ko for testing
if(XDNA_DRV_PF_SRC_DIR)
  install(FILES ${XDNA_DRV_PATH} ${XDNA_DRV_PF_PATH} DESTINATION ${XDNA_BIN_DIR}/driver)
else()
  install(FILES ${XDNA_DRV_PATH} DESTINATION ${XDNA_BIN_DIR}/driver)
endif()

set(amdxdna_drv_tools
  ${CMAKE_CURRENT_SOURCE_DIR}/tools/configure_kernel.sh
  ${CMAKE_CURRENT_SOURCE_DIR}/tools/dkms_driver.sh
  ${CMAKE_CURRENT_SOURCE_DIR}/tools/npu_perf_trace.sh
  ${CMAKE_CURRENT_SOURCE_DIR}/tools/npu_perf_analyze.sh
  ${CMAKE_CURRENT_SOURCE_DIR}/tools/io_page_fault_flags
  )
install(FILES ${amdxdna_drv_tools}
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
  DESTINATION ${XDNA_PKG_DATA_DIR}
  COMPONENT ${XDNA_COMPONENT}
  )

=== xdna/xdna-driver/src/shim/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022-2025, Advanced Micro Devices, Inc. All rights reserved.

set(XDNA_TARGET xrt_driver_xdna)
set(XRT_CORE_TARGET xrt_core)
set(XRT_COREUTIL_TARGET xrt_coreutil)

aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR} MAIN_SOURCES)
aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR}/kmq KMQ_SOURCES)
aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR}/umq UMQ_SOURCES)
aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR}/host HOST_SOURCES)
aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR}/virtio VIRTIO_SOURCES)
add_library(${XDNA_TARGET} SHARED
  ${MAIN_SOURCES}
  ${KMQ_SOURCES}
  ${UMQ_SOURCES}
  ${HOST_SOURCES}
  ${VIRTIO_SOURCES}
  )

set_target_properties(${XDNA_TARGET} PROPERTIES
  VERSION ${XRT_PLUGIN_VERSION_STRING}
  SOVERSION ${XRT_SOVERSION}
  )

target_compile_definitions(${XDNA_TARGET} PRIVATE
  # below macros is required so that i/f defined in ishim.h is
  # consistent with native xrt implementation
  XRT_ENABLE_AIE
  XRT_AIE_BUILD
  XRT_BUILD
  $<$<CONFIG:Debug>:XDNA_SHIM_DEBUG>
  )

if(${UMQ_HELLO_TEST})
  add_definitions(-DUMQ_HELLO_TEST)
endif()

target_compile_options(${XDNA_TARGET} PRIVATE
  "-fPIC"
  )

target_include_directories(${XDNA_TARGET} PRIVATE
  ${XRT_SOURCE_DIR}/runtime_src
  ${XRT_SOURCE_DIR}/runtime_src/core/include
  ${XRT_SOURCE_DIR}/runtime_src/core/common/gsl/include
  ${XRT_BINARY_DIR}/gen
  ${CMAKE_CURRENT_SOURCE_DIR}/../include/uapi
  )

# driver plugin will be loaded while xrt_core is still being
# dlopen'ed, symbols against libxrt_core.so can't be solved
# at that time, so need to be fully solved here.
target_link_libraries(${XDNA_TARGET} PRIVATE
  xrt_core
  ${XRT_CORE_TARGET}
  ${XRT_COREUTIL_TARGET}
  )

target_link_options(${XDNA_TARGET} PRIVATE
  "-Wl,-z,defs"
  )

# install components for packaging
install(TARGETS ${XDNA_TARGET}
  LIBRARY DESTINATION ${XDNA_PKG_LIB_DIR}
  NAMELINK_SKIP
  COMPONENT ${XDNA_COMPONENT}
  )

# install components for testing
install(TARGETS ${XRT_CORE_TARGET} DESTINATION ${XDNA_BIN_DIR}/${XDNA_PKG_LIB_DIR})
install(TARGETS ${XRT_COREUTIL_TARGET} DESTINATION ${XDNA_BIN_DIR}/${XDNA_PKG_LIB_DIR})
install(TARGETS ${XDNA_TARGET} DESTINATION ${XDNA_BIN_DIR}/${XDNA_PKG_LIB_DIR})

=== xrt/XRT/src/runtime_src/xocl/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
# Copyright (C) 2025 Advanced Micro Devices, Inc. All rights reserved.
include_directories(
  ${Boost_INCLUDE_DIRS}
  ${XRT_SOURCE_DIR}/include/1_2
)

set(XRT_XOCL_API_DIR       "${CMAKE_CURRENT_SOURCE_DIR}/api")
set(XRT_XOCL_CORE_DIR      "${CMAKE_CURRENT_SOURCE_DIR}/core")
set(XRT_XOCL_XCLBIN_DIR    "${CMAKE_CURRENT_SOURCE_DIR}/xclbin")

include_directories(
  ${XRT_XOCL_API_DIR}
)

file(GLOB XRT_XOCL_API_FILES
  "${XRT_XOCL_API_DIR}/*.cpp"
  "${XRT_XOCL_API_DIR}/detail/*.cpp"
  "${XRT_XOCL_API_DIR}/icd/*.cpp"
  "${XRT_XOCL_API_DIR}/khronos/*.cpp"
  "${XRT_XOCL_API_DIR}/xlnx/*.cpp"
  "${XRT_XOCL_API_DIR}/printf/*.cpp"
  "${XRT_XOCL_API_DIR}/plugin/xdp/*.cpp"
  )

file(GLOB XRT_XOCL_CORE_FILES
  "${XRT_XOCL_CORE_DIR}/*.cpp"
  )

file(GLOB XRT_XOCL_XCLBIN_FILES
  "${XRT_XOCL_XCLBIN_DIR}/*.cpp"
  )

set(XRT_XOCL_ALL_SRC
  ${XRT_XOCL_API_FILES}
  ${XRT_XOCL_CORE_FILES}
  ${XRT_XOCL_XCLBIN_FILES}
  )

add_compile_options("-DXRT_XOCL_SOURCE")

add_library(xocl OBJECT ${XRT_XOCL_ALL_SRC})

if (WIN32)
include_directories(
  ${KHRONOS}/include
  )

xrt_configure_version_file(xilinxopencl SHARED)
add_library(xilinxopencl SHARED
  xilinxopencl-version.rc
  $<TARGET_OBJECTS:xocl>
  ${XRT_XOCL_API_DIR}/icd/windows/xilinxopencl.def
  )

add_library(xilinxopencl_static STATIC
  $<TARGET_OBJECTS:xocl>
  )

target_link_libraries(xilinxopencl
  PRIVATE
  xrt++
  xrt_coreutil
  )

else ()

add_library(xilinxopencl SHARED $<TARGET_OBJECTS:xocl>)
add_library(xilinxopencl_static STATIC $<TARGET_OBJECTS:xocl>)

# Attach to the user's linker flags
set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-Bsymbolic")
set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,defs")

set_target_properties(xilinxopencl PROPERTIES
  LINKER_LANGUAGE CXX
  VERSION ${XRT_VERSION_STRING}
  SOVERSION ${XRT_SOVERSION}
  )

target_link_libraries(xilinxopencl
  PRIVATE
  xrt++
  xrt_coreutil
  dl
  pthread
  uuid
  )

  # On linux use xrt_coreutil.a
  set_target_properties(xilinxopencl_static PROPERTIES OUTPUT_NAME "xilinxopencl")

endif ()

# Install shared library with export to xrt-targets
install(TARGETS xilinxopencl
  EXPORT xrt-targets
  RUNTIME DESTINATION ${XRT_INSTALL_BIN_DIR} COMPONENT ${XRT_BASE_COMPONENT}
  LIBRARY DESTINATION ${XRT_INSTALL_LIB_DIR} COMPONENT ${XRT_BASE_COMPONENT} NAMELINK_COMPONENT ${XRT_BASE_DEV_COMPONENT}
  ARCHIVE DESTINATION ${XRT_INSTALL_LIB_DIR} COMPONENT ${XRT_BASE_DEV_COMPONENT}
)

# Install static library - exclude from xrt-targets export in yocto builds
# to avoid find_package(XRT) failures when static libs are not in sysroot
if(XRT_YOCTO)
  install(TARGETS xilinxopencl_static
    ARCHIVE DESTINATION ${XRT_INSTALL_LIB_DIR} COMPONENT ${XRT_BASE_DEV_COMPONENT})
else()
  install(TARGETS xilinxopencl_static
    EXPORT xrt-targets
    ARCHIVE DESTINATION ${XRT_INSTALL_LIB_DIR} COMPONENT ${XRT_BASE_DEV_COMPONENT})
endif()

set(CL_DEST_DIR ${XRT_INSTALL_INCLUDE_DIR}/)
if(XRT_EDGE)
  set(CL_DEST_DIR ${XRT_INSTALL_INCLUDE_DIR}/xrt/)
endif()

# Release OpenCL extension headers
install (FILES
  ${XRT_SOURCE_DIR}/include/1_2/CL/cl_ext_xilinx.h
  DESTINATION ${CL_DEST_DIR}/CL
  COMPONENT ${XRT_BASE_DEV_COMPONENT}
)

# Preserve legacy behavior in legacy XRT package. The component
# setup will have defined XRT_BASE_DEV_COMPONENT to XRT
if (XRT_XRT OR XRT_EDGE)
  install (FILES
    ${XRT_SOURCE_DIR}/include/1_2/CL/cl_ext.h
    ${XRT_SOURCE_DIR}/include/1_2/CL/cl2xrt.hpp
    DESTINATION ${CL_DEST_DIR}/CL
    COMPONENT ${XRT_BASE_DEV_COMPONENT}
    )
endif ()

=== xrt/XRT/src/runtime_src/tools/scripts/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
#
if (NOT WIN32)
  set(XRT_SETUP_SCRIPTS
    setup.sh
    setup.fish
    setup.csh)

  set(XRT_LOADER_SCRIPTS
    loader)

  set (XRT_SCRIPTS
    service_bundle.sh
    plp_program.sh)

else()

  set(XRT_SETUP_SCRIPTS
    setup.bat)

  set (XRT_LOADER_SCRIPTS
    loader.bat)

endif(NOT WIN32)

if (XRT_BASE)
  # Do not install loader or setup scripts if installing into system default
  if (NOT XRT_INSTALL_BIN_DIR STREQUAL XRT_INSTALL_UNWRAPPED_DIR)
    install (PROGRAMS ${XRT_LOADER_SCRIPTS}
      DESTINATION ${XRT_INSTALL_UNWRAPPED_DIR}
      COMPONENT ${XRT_BASE_COMPONENT})

    install (FILES ${XRT_SETUP_SCRIPTS}
      DESTINATION ${XRT_INSTALL_DIR}
      COMPONENT ${XRT_BASE_COMPONENT})
  endif()
endif()

if (XRT_ALVEO)
  install (PROGRAMS ${XRT_SCRIPTS}
    DESTINATION ${XRT_INSTALL_BIN_DIR}
    COMPONENT ${XRT_COMPONENT})
endif()

=== xrt/XRT/src/runtime_src/tools/xclbinutil/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2024, Advanced Micro Devices, Inc. All rights Reserved.
#
# Signing xclbin images are currently only support on Linux
cmake_minimum_required(VERSION 3.5...4.0)
project(XCLBINUTIL)

# This cmake project depends on some other cmake util files
# which can be found in folder ${XRT_SOURCE_DIR}/CMake.
if ("${XRT_SOURCE_DIR}" STREQUAL "")
  message(FATAL_ERROR, "XRT_SOURCE_DIR is not set, 
          if building xclbinutil only please set it to point <XRT>/src folder")
endif()

# --- Helper CMake files includes ---
include (${XRT_SOURCE_DIR}/CMake/settings.cmake)
include (${XRT_SOURCE_DIR}/CMake/utilities.cmake)
include (${XRT_SOURCE_DIR}/CMake/boostUtil.cmake)

# cmake 3.19 and after emits warning about this policy not being set
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.19)
  cmake_policy(SET CMP0110 NEW)
endif(CMAKE_VERSION VERSION_GREATER_EQUAL 3.19)

if(NOT WIN32)
  find_package(OpenSSL REQUIRED)
  if (NOT XRT_EDGE)
    # Cannot use find_package(PythonInterp REQUIRED) as it pollutes the
    # global space and later causes failure with find_package(pybind11 ...)
    # in src/python/pybind11/CMakeLists.txt
    find_program(PYTHON_EXECUTABLE python3)
  endif()
endif()

# Windows support coming soon
if(NOT WIN32)
  # On Ubuntu 16.04 CMake support is limited
  if ((${LINUX_FLAVOR} STREQUAL "ubuntu") AND ("x${LINUX_VERSION}x" STREQUAL "x16.04x"))
    set(RapidJSON_VERSION_MAJOR 0)
  else()
    find_package(RapidJSON REQUIRED)
  endif()
endif()

# Need pthreads for the boost processes
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

# --- XRT Variables ---
include (${XRT_SOURCE_DIR}/CMake/xrtVariables.cmake)
include (${XRT_SOURCE_DIR}/CMake/version.cmake)

include_directories(
  ${XRT_SOURCE_DIR}/runtime_src/core/include
  ${PROJECT_BINARY_DIR}/gen
  )

if (NOT XRT_EDGE)
  add_subdirectory(
    ${XRT_SOURCE_DIR}/runtime_src/tools/scripts 
    ${PROJECT_BINARY_DIR}/runtime_src/tools/scripts
    )
  enable_testing()
endif()

# ==-- x c l b i n u t i l --==================================================

add_subdirectory(aie-pdi-transform)

set(XCLBINUTIL_NAME "xclbinutil")

set(XRT_LOADER_SCRIPTS ${XCLBINUTIL_NAME})

if(WIN32)
  # Add the command shell wrapper in addition to the bash shell wrapper.
  # Note: The bash shell wrapper is smart and will call this wrapper
  list(APPEND XRT_LOADER_SCRIPTS ${XCLBINUTIL_NAME}.bat)
endif()

file(GLOB XCLBINUTIL_FILES
  "DTC*.cxx"
  "FDT*.cxx"
  "CBOR.cxx"
  "RapidJsonUtilities.cxx"
  "KernelUtilities.cxx"
  "ElfUtilities.cxx"
  "FormattedOutput.cxx"
  "ParameterSectionData.cxx"
  "Section.cxx"     # Note: Due to linking dependency issue, this entry needs to be before the other sections
  "Section*.cxx"
  "Resources*.cxx"
  "XclBinClass.cxx"
  "XclBinSignature.cxx"
  "XclBinUtilities.cxx"
  "XclBinUtilMain.cxx"
)
set(XCLBINUTIL_FILES_SRCS ${XCLBINUTIL_FILES})

file(GLOB XCLBINUTIL_MAIN_FILE
  "xclbinutil.cxx"
)
set(XCLBINUTIL_SRCS ${XCLBINUTIL_MAIN_FILE} ${XCLBINUTIL_FILES_SRCS})

xrt_configure_version_file(${XCLBINUTIL_NAME} APP)
add_executable(${XCLBINUTIL_NAME} ${XCLBINUTIL_NAME}-version.rc ${XCLBINUTIL_SRCS})

# Signing xclbin images currently is not support on windows
if(NOT WIN32)
  target_link_libraries(${XCLBINUTIL_NAME} PRIVATE crypto)
endif()

# Add compile definitions
if(NOT WIN32)
  if(${RapidJSON_VERSION_MAJOR} GREATER 0)
    target_compile_definitions(${XCLBINUTIL_NAME} PRIVATE ENABLE_JSON_SCHEMA_VALIDATION)
  endif()
endif()

target_link_libraries(${XCLBINUTIL_NAME} PRIVATE ${Boost_LIBRARIES} Threads::Threads)

# link the aie-pdi-transform static library
target_link_libraries(${XCLBINUTIL_NAME} PRIVATE transformcdo)

# Link required windows specific libraries with MinGW
if(WIN32 AND (CMAKE_CXX_COMPILER_ID STREQUAL "GNU"))
  target_link_libraries(${XCLBINUTIL_NAME} PRIVATE wsock32 ws2_32)
endif()

install (TARGETS ${XCLBINUTIL_NAME}
  RUNTIME DESTINATION ${XRT_INSTALL_UNWRAPPED_DIR} COMPONENT ${XRT_BASE_COMPONENT})

# Do not install loader scripts if installing into system default
if (NOT XRT_INSTALL_BIN_DIR STREQUAL XRT_INSTALL_UNWRAPPED_DIR)
  install (PROGRAMS ${XRT_LOADER_SCRIPTS}
    DESTINATION ${XRT_INSTALL_BIN_DIR} COMPONENT ${XRT_BASE_COMPONENT})
endif()

# ==-- x c l b i n t e s t --==================================================
SET(TEST_SUITE_NAME "xclbinutil")

include (${XRT_SOURCE_DIR}/CMake/unitTestSupport.cmake)

# OpenSSL encryption is only supported on linux
if(NOT WIN32 AND NOT XRT_SYSTEM_INSTALL)
  # -- Test Signing of the xclbin image using a CER formatted certificate
  xrt_add_test("signing-xclbin_CER" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/signXclbinCER.py")

  # -- Test Signing of the xclbin image using a DER formatted certificate
  xrt_add_test("signing-xclbin_DER" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/signXclbinDER.py")

  if (NOT XRT_NPU)
    # The xclbin image must contain atleast one section and platformVBNV information to meet
    # the expectations of Linux file command utility
    # -- Test --file-check option on valid and invalid xclbin images for Linux file command 
    set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/FileCheck")
    xrt_add_test("file-check" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/FileCheck/FileCheck.py ${TEST_OPTIONS}")
  endif()
  
  # -- Test SmartNic
  # Test: SmartNic Syntax
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/SmartNic")
  xrt_add_test("smartnic-syntax" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/SmartNic/SectionSmartNicSyntax.py ${TEST_OPTIONS}")

  # Test: SmartNic Schema
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/SmartNic")
  xrt_add_test("smartnic-format" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/SmartNic/SectionSmartNicFormat.py ${TEST_OPTIONS}")

  if (CMAKE_INSTALL_PREFIX STREQUAL "/opt/xilinx/xrt")
    # -- SoftKernel
    set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/SoftKernel")
    xrt_add_test("soft-kernel" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/SoftKernel/SectionSoftKernel.py ${TEST_OPTIONS}")
  endif()

  # -- Partion Metadata
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/PartitionMetadata")
  xrt_add_test("partition_metadata" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/PartitionMetadata/SectionPartitionMetadata.py ${TEST_OPTIONS}")

  # -- Fixed Kernels
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/FixedKernel")
  xrt_add_test("fixed-kernel" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/FixedKernel/FixedKernel.py ${TEST_OPTIONS}")

  # -- PS Kernels
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/PSKernel")
  xrt_add_test("ps-kernel" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/PSKernel/PSKernel.py ${TEST_OPTIONS}")

  # -- Binary Images
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/BinaryImages")
  xrt_add_test("binary-images" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/BinaryImages/BinaryImages.py ${TEST_OPTIONS}")

  # -- Single Subsection
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/SingleSubsection")
  xrt_add_test("single-subsection" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/SingleSubsection/SingleSubsection.py ${TEST_OPTIONS}")

  # -- AIE Partition
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/AIEPartition")
  xrt_add_test("aie-partition" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/AIEPartition/AIEPartition.py ${TEST_OPTIONS}")

  # -- BMC Section
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/BMC")
  xrt_add_test("bmc" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/BMC/BMCSection.py ${TEST_OPTIONS}")

  # -- MCS Section
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/MCS")
  xrt_add_test("mcs" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/MCS/MCSSection.py ${TEST_OPTIONS}")

  # -- IP_MEDATADA Section
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/IPMetadata")
  xrt_add_test("ip-metadata" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/IPMetadata/IPMetadata.py ${TEST_OPTIONS}")

  # -- AIE RESOURCES BIN Section
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/AieResourcesBin")
  xrt_add_test("AieResourcesBin" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/AieResourcesBin/SectionAieResourcesBin.py ${TEST_OPTIONS}")

  # -- AIE TRACE METADATA Section
  set(TEST_OPTIONS " --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/AieTraceMetadata")
  xrt_add_test("AieTraceMetadata" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/unittests/AieTraceMetadata/SectionAieTraceMetadata.py ${TEST_OPTIONS}")


endif()


if (WIN32)
  set(GTEST_ROOT "C:/Xilinx/XRT/ext")
endif()

find_package(GTest)

if (GTEST_FOUND AND NOT XRT_SYSTEM_INSTALL)
  set(UNIT_TEST_NAME "xclbintest")

  include_directories(${GTEST_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR})

  # Build everything in the unittest directory
  file(GLOB XCLBINTEST_FILES
    "unittests/*.cxx"
  )

  set(XCLBINTEST_SRCS ${XCLBINTEST_FILES} ${XCLBINUTIL_FILES_SRCS})
  add_executable(${UNIT_TEST_NAME} ${XCLBINTEST_SRCS})

  if(WIN32)
    target_link_libraries(${UNIT_TEST_NAME} PRIVATE Boost::program_options Boost::system )
    target_link_libraries(${UNIT_TEST_NAME} PRIVATE ${GTEST_BOTH_LIBRARIES})
  else()
    target_link_libraries(${UNIT_TEST_NAME} PRIVATE ${Boost_LIBRARIES} ${GTEST_BOTH_LIBRARIES} pthread crypto)

    if(NOT (${RapidJSON_VERSION_MAJOR} EQUAL 0))
      target_compile_definitions(${UNIT_TEST_NAME} PRIVATE ENABLE_JSON_SCHEMA_VALIDATION)
    endif()
  endif()

  # link the aie-pdi-transform static library
  target_link_libraries(${UNIT_TEST_NAME} PRIVATE transformcdo)

  # Add the test
  set(TEST_EXECUTABLE "${CMAKE_CURRENT_BINARY_DIR}/${UNIT_TEST_NAME}")
  set(TEST_OPTIONS "--quiet --resource-dir ${CMAKE_CURRENT_SOURCE_DIR}/unittests/test_data")
  xrt_add_test(${UNIT_TEST_NAME} "${TEST_EXECUTABLE}" "${TEST_OPTIONS}")

else()
  message (STATUS "GTest was not found, skipping generation of test executables")
endif()
# -----------------------------------------------------------------------------

=== xrt/XRT/src/runtime_src/xdp/profile/plugin/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022-2025 Advanced Micro Devices, Inc.  All rights reserved.
#

if (XDP_VE2_BUILD_CMAKE STREQUAL "yes")
  add_subdirectory(aie_status)
  add_subdirectory(aie_profile)  
  add_subdirectory(aie_trace)
  add_subdirectory(ml_timeline)
  add_subdirectory(aie_halt)
  add_subdirectory(native)
  add_subdirectory(user)

elseif (XDP_CLIENT_BUILD_CMAKE STREQUAL "yes")

  add_subdirectory(native)
  add_subdirectory(user)
  add_subdirectory(ml_timeline)
  add_subdirectory(aie_trace)
  add_subdirectory(aie_profile)

  if (WIN32)
    add_subdirectory(aie_halt)
    add_subdirectory(aie_pc)
  endif()
   
else()

# =========================================================
# The plugins to be built on both Linux and Windows
# =========================================================
add_subdirectory(device_offload/opencl)
add_subdirectory(device_offload/hal)
add_subdirectory(hal)
add_subdirectory(hal_api_interface)
add_subdirectory(lop)
add_subdirectory(native)
add_subdirectory(opencl/counters)
add_subdirectory(opencl/trace)
add_subdirectory(pl_deadlock)
add_subdirectory(user)

if (NOT WIN32)
# =========================================================
# The plugins to be built on Linux only
# =========================================================
add_subdirectory(aie_status)
add_subdirectory(aie_profile)
add_subdirectory(aie_trace)
add_subdirectory(device_offload/hw_emu)
add_subdirectory(noc)
add_subdirectory(power)
add_subdirectory(system_compiler)
add_subdirectory(vart)

else()
# =========================================================
# The plugins to be built on Windows only (currently empty)
# =========================================================

endif()

# Matches XDP_CLIENT_BUILD_CMAKE
endif()

=== xrt/XRT/src/runtime_src/core/edge/drm/zocl/Makefile ===
KERNEL_SRC ?= /lib/modules/$(shell uname -r)/build

# Base on Linux Documentation/kbuild/modules.txt.
# $(src) provides the absolute path by pointing to the directory
# where the currently executing kbuild file is located.
ifneq ($(src),)
# building modules
ifneq ($(wildcard $(src)/../common),)
# dkms flow
common_dir := ../common
else
# build from source code
common_dir := ../../../common/drv
endif

else
# clean
make_dir := $(abspath $(dir $(lastword $(MAKEFILE_LIST))))
common_dir := $(make_dir)/../../../common/drv
ifeq ($(wildcard $(make_dir)/../../../common/drv),)
common_dir := $(make_dir)/../common
endif

endif

ccflags-y := -I$(src)/include -I$(src)/../../include -I$(src)/../../../include -I$(src)/../../../common/drv/include

#flags passed from xrt_git.bb file are added below
ifneq ($(cflags_zocl),)
	ccflags-y += $(cflags_zocl)
endif

ccflags-y += -Wall

# Version adjusted to 2.21 for master
XRT_DRIVER_VERSION ?= 2.21.0

# Add patch number in version if 'XRT_VERSION_PATCH' env variable is defined
ifneq ($(XRT_VERSION_PATCH),)
	XRT_DRIVER_VERSION:=$(XRT_DRIVER_VERSION:.0=.$(XRT_VERSION_PATCH))
endif

drv_common-y   := $(common_dir)/kds_hwctx.o \
                  $(common_dir)/kds_core.o \
                  $(common_dir)/cu_hls.o \
                  $(common_dir)/fast_adapter.o \
                  $(common_dir)/xrt_cu.o \
                  $(common_dir)/xrt_xclbin.o

zocl_common_dir := $(make_dir)/common
zocl_common-y := $(zocl_common_dir)/zocl_sysfs.o \
	$(zocl_common_dir)/zocl_ioctl.o \
	$(zocl_common_dir)/zocl_drv.o \
	$(zocl_common_dir)/zocl_bo.o \
	$(zocl_common_dir)/zocl_xclbin.o \
	$(zocl_common_dir)/zocl_kds.o \
	$(zocl_common_dir)/cu.o 

zocl_edge_dir := $(make_dir)/edge
zocl_edge-y := $(zocl_edge_dir)/zocl_dma.o \
	$(zocl_edge_dir)/zocl_cu.o \
	$(zocl_edge_dir)/zocl_mailbox.o \
	$(zocl_edge_dir)/zocl_edge_xclbin.o \
	$(zocl_edge_dir)/zocl_edge_kds.o \
	$(zocl_edge_dir)/zocl_error.o \
	$(zocl_edge_dir)/zocl_aie.o \
	$(zocl_edge_dir)/zocl_hwctx.o

zocl_zert_dir := $(make_dir)/zert
zocl_zert-y := $(zocl_zert_dir)/zocl_ert.o \
	$(zocl_zert_dir)/zocl_ov_sysfs.o \
	$(zocl_zert_dir)/zocl_ospi_versal.o \
	$(zocl_zert_dir)/zocl_ps_xclbin.o \
	$(zocl_zert_dir)/zocl_sk.o \
	$(zocl_zert_dir)/zocl_ps_kds.o \
	$(zocl_zert_dir)/cu_scu.o \
	$(zocl_zert_dir)/scu.o \
	$(zocl_zert_dir)/zocl_ctrl_ert.o \
	$(zocl_zert_dir)/zocl_xgq.o \
	$(zocl_zert_dir)/zocl_lib.o \
	$(zocl_zert_dir)/zocl_cu_xgq.o \
	$(zocl_zert_dir)/zocl_rpu_channel.o \
	$(zocl_zert_dir)/zocl_csr_intc.o \
	$(zocl_zert_dir)/zocl_xgq_intc.o

zocl-y := \
	$(drv_common-y) \
	$(zocl_common-y) \
	$(zocl_edge-y) \
	$(zocl_zert-y)

obj-m	+= zocl.o

SRC := $(shell pwd)

all: modules

git_variables:
	$(eval GIT_HASH ?= $(shell git rev-parse --verify HEAD))
	$(eval GIT_HASH_DATE ?= $(shell git log -1 --pretty=format:%cD))
	$(eval GIT_BRANCH ?= $(shell git rev-parse --abbrev-ref HEAD))
	$(eval TMP_MODIFIED_FILES ?= $(shell git status --porcelain -uno))
	$(eval GIT_MODIFIED_FILES ?= $(subst \\n,\,,$(TMP_MODIFIED_FILES)))
	$(eval DATE_NOW ?= $(shell date "+%Y-%m-%d"))

	$(eval cflags_module := -DXRT_HASH="\"$(GIT_HASH)\"" -DXRT_HASH_DATE="\"$(GIT_HASH_DATE)\"" -DXRT_BRANCH="\"$(GIT_BRANCH)\"" -DXRT_MODIFIED_FILES="\"$(GIT_MODIFIED_FILES)\"" -DXRT_DATE="\"$(DATE_NOW)\"" -DXRT_DRIVER_VERSION="\"$(XRT_DRIVER_VERSION)\"")

modules: git_variables
	$(MAKE) -C $(KERNEL_SRC) M=$(SRC) CFLAGS_MODULE='$(cflags_module)' modules

modules_install:
	$(MAKE) -C $(KERNEL_SRC) M=$(SRC) modules_install

clean:
	rm -f *.o *~ core .depend .*.cmd *.ko *.mod.c *.mod
	rm -f $(zocl_common_dir)/*.o $(zocl_edge_dir)/*.o $(zocl_zert_dir)/*.o
	rm -f Module.markers Module.symvers modules.order
	rm -rf .tmp_versions Modules.symvers
	$(MAKE) -C $(common_dir) clean

=== xrt/XRT/src/runtime_src/core/tools/xbutil2/EventTracing/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2025 Advanced Micro Devices, Inc. All rights reserved.

# Collect EventTrace source files with full paths
file(GLOB EVENT_TRACE_FILES
  "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)

# Add source files to parent's collection
list(APPEND XBUTIL_V2_SUBCMD_FILES ${EVENT_TRACE_FILES})
set(XBUTIL_V2_SUBCMD_FILES ${XBUTIL_V2_SUBCMD_FILES} PARENT_SCOPE)

=== xrt/XRT/src/runtime_src/core/tools/xbutil2/FirmwareLogging/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2025 Advanced Micro Devices, Inc. All rights reserved.

# Collect EventTrace source files with full paths
file(GLOB FIRMWARE_LOG_FILES
  "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)

# Add source files to parent's collection
list(APPEND XBUTIL_V2_SUBCMD_FILES ${FIRMWARE_LOG_FILES})
set(XBUTIL_V2_SUBCMD_FILES ${XBUTIL_V2_SUBCMD_FILES} PARENT_SCOPE)

=== xrt/XRT/src/runtime_src/xdp/profile/plugin/aie_pc/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2024 Advanced Micro Devices, Inc.  All rights reserved.
#

# ========================================================================
# This builds the AIE PC Plugin which can configure Perf Counter registers
# to count cycles between core function start and end.
# It is currently built on Client Windows Only.
# =========================================================================

if (XDP_CLIENT_BUILD_CMAKE STREQUAL "yes")
  set(IMPL_DIR "${PROFILE_DIR}/plugin/aie_pc/clientDev")
endif()


file(GLOB XDP_AIE_PC_PLUGIN_FILES
  "${PROFILE_DIR}/plugin/aie_pc/*.h"
  "${PROFILE_DIR}/plugin/aie_pc/*.cpp"
  "${IMPL_DIR}/*.h"
  "${IMPL_DIR}/*.cpp"
)

file(GLOB XDP_DEVICE_COMMON_FILES
  "${PROFILE_DIR}/device/common/*.h"
  "${PROFILE_DIR}/device/common/*.cpp"
)

if (XDP_CLIENT_BUILD_CMAKE STREQUAL "yes")
  xrt_configure_version_file(xdp_aie_pc_plugin SHARED)
  add_library(xdp_aie_pc_plugin SHARED xdp_aie_pc_plugin-version.rc
    ${XDP_AIE_PC_PLUGIN_FILES} ${XDP_DEVICE_COMMON_FILES})
  add_dependencies(xdp_aie_pc_plugin xdp_core xrt_coreutil)
  target_link_libraries(xdp_aie_pc_plugin PRIVATE xdp_core xrt_coreutil xaiengine)
  target_compile_definitions(xdp_aie_pc_plugin PRIVATE XDP_CLIENT_BUILD=1 -DXAIE_FEATURE_MSVC)
  target_include_directories(xdp_aie_pc_plugin PRIVATE ${AIERT_DIR}/include)
  set_target_properties(xdp_aie_pc_plugin PROPERTIES VERSION ${XRT_VERSION_STRING} SOVERSION ${XRT_SOVERSION})

  install (TARGETS xdp_aie_pc_plugin
    RUNTIME DESTINATION ${XDP_PLUGIN_INSTALL_DIR} COMPONENT ${XRT_COMPONENT}
    LIBRARY DESTINATION ${XDP_PLUGIN_INSTALL_DIR} COMPONENT ${XRT_COMPONENT} ${XRT_NAMELINK_SKIP}
  )

# Else, on edge-aarch64 don't build at all

endif()

=== xrt/XRT/src/runtime_src/xdp/profile/plugin/aie_trace/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022-2025 Advanced Micro Devices, Inc.  All rights reserved.
#

# ====================================================================
# This builds the AIE Trace plugin.  It is currently built on x86,
# Edge-Versal systems, client and ve2 but not Edge-aarch64.  It also has a dependency
# on the hardware shim
# ====================================================================

file(GLOB AIE_TRACE_PLUGIN_FILES
  "${PROFILE_DIR}/plugin/aie_trace/*.h"
  "${PROFILE_DIR}/plugin/aie_trace/*.cpp"
  "${PROFILE_DIR}/writer/aie_trace/*.h"
  "${PROFILE_DIR}/writer/aie_trace/*.cpp"
)
file(GLOB AIE_TRACE_UTIL_FILES
  "${PROFILE_DIR}/plugin/aie_base/*"
  "${PROFILE_DIR}/plugin/aie_base/generations/*"
  "${PROFILE_DIR}/plugin/aie_trace/util/aie_trace_util.h"
  "${PROFILE_DIR}/plugin/aie_trace/util/aie_trace_util.cpp"
)
file(GLOB AIE_TRACE_CONFIG_FILES
  "${PROFILE_DIR}/plugin/aie_trace/util/aie_trace_config.h"
  "${PROFILE_DIR}/plugin/aie_trace/util/aie_trace_config.cpp"
)

if (XDP_CLIENT_BUILD_CMAKE STREQUAL "yes")
  set(IMPL_DIR "${PROFILE_DIR}/plugin/aie_trace/client")
  set(OFFLOAD_DIR "${PROFILE_DIR}/device/aie_trace/client")
  set(DEVICE_DIR "${PROFILE_DIR}/device/client_device")

  file(GLOB AIE_DRIVER_COMMON_UTIL_FILES
    "${PROFILE_DIR}/device/common/*.h"
    "${PROFILE_DIR}/device/common/*.cpp"
  )

  file(GLOB AIE_TRACE_COMPONENT_FILES
    "${OFFLOAD_DIR}/*.h"
    "${OFFLOAD_DIR}/*.cpp"
    "${DEVICE_DIR}/*.h"
    "${DEVICE_DIR}/*.cpp"
    "${IMPL_DIR}/*.h"
    "${IMPL_DIR}/*.cpp"
  )

  xrt_configure_version_file(xdp_aie_trace_plugin SHARED)
  add_library(xdp_aie_trace_plugin SHARED xdp_aie_trace_plugin-version.rc
    ${AIE_TRACE_PLUGIN_FILES} ${AIE_TRACE_COMPONENT_FILES} ${AIE_TRACE_UTIL_FILES} ${AIE_DRIVER_COMMON_UTIL_FILES})
  add_dependencies(xdp_aie_trace_plugin xdp_core xrt_coreutil)
  target_link_libraries(xdp_aie_trace_plugin PRIVATE xdp_core xrt_coreutil xaiengine)
  target_compile_definitions(xdp_aie_trace_plugin PRIVATE XDP_CLIENT_BUILD=1 -DXAIE_FEATURE_MSVC)
  target_include_directories(xdp_aie_trace_plugin PRIVATE ${AIERT_DIR}/include)
  set_target_properties(xdp_aie_trace_plugin PROPERTIES VERSION ${XRT_VERSION_STRING} SOVERSION ${XRT_SOVERSION})

  install (TARGETS xdp_aie_trace_plugin
    RUNTIME DESTINATION ${XDP_PLUGIN_INSTALL_DIR} COMPONENT ${XRT_COMPONENT}
    LIBRARY DESTINATION ${XDP_PLUGIN_INSTALL_DIR} COMPONENT ${XRT_COMPONENT} ${XRT_NAMELINK_SKIP}
  )

elseif (DEFINED XRT_AIE_BUILD AND (NOT XRT_EDGE))
  set(IMPL_DIR "${PROFILE_DIR}/plugin/aie_trace/x86")
  set(OFFLOAD_DIR "${PROFILE_DIR}/device/aie_trace")
  set(DEVICE_DIR "${PROFILE_DIR}/device/hal_device")

  file(GLOB AIE_TRACE_COMPONENT_FILES
    "${OFFLOAD_DIR}/*.h"
    "${OFFLOAD_DIR}/*.cpp"
    "${DEVICE_DIR}/*.h"
    "${DEVICE_DIR}/*.cpp"
    "${IMPL_DIR}/*.h"
    "${IMPL_DIR}/*.cpp"
  )

  xrt_configure_version_file(xdp_aie_trace_plugin SHARED)
  add_library(xdp_aie_trace_plugin SHARED xdp_aie_trace_plugin-version.rc
    ${AIE_TRACE_PLUGIN_FILES} ${AIE_TRACE_COMPONENT_FILES})
  add_dependencies(xdp_aie_trace_plugin xdp_core xrt_coreutil)
  target_link_libraries(xdp_aie_trace_plugin PRIVATE xdp_core xrt_coreutil)
  target_compile_definitions(xdp_aie_trace_plugin PRIVATE XRT_X86_BUILD=1)
  set_target_properties(xdp_aie_trace_plugin PROPERTIES VERSION ${XRT_VERSION_STRING} SOVERSION ${XRT_SOVERSION})

  install (TARGETS xdp_aie_trace_plugin
    RUNTIME DESTINATION ${XDP_PLUGIN_INSTALL_DIR} COMPONENT ${XRT_COMPONENT}
    LIBRARY DESTINATION ${XDP_PLUGIN_INSTALL_DIR} COMPONENT ${XRT_COMPONENT} ${XRT_NAMELINK_SKIP}
  )  

else()
  if (XDP_VE2_BUILD_CMAKE STREQUAL "yes")
    set(IMPL_DIR "${PROFILE_DIR}/plugin/aie_trace/ve2")
    set(OFFLOAD_DIR "${PROFILE_DIR}/device/aie_trace/ve2")
    set(DEVICE_DIR "${PROFILE_DIR}/device/hal_device")

    file(GLOB AIE_TRACE_COMPONENT_FILES
      "${OFFLOAD_DIR}/*.h"
      "${OFFLOAD_DIR}/*.cpp"
      "${DEVICE_DIR}/*.h"
      "${DEVICE_DIR}/*.cpp"
      "${IMPL_DIR}/*.h"
      "${IMPL_DIR}/*.cpp"
    )

    add_library(xdp_aie_trace_plugin_xdna SHARED ${AIE_TRACE_PLUGIN_FILES} ${AIE_TRACE_COMPONENT_FILES} ${AIE_TRACE_UTIL_FILES} ${AIE_TRACE_CONFIG_FILES})
    add_dependencies(xdp_aie_trace_plugin_xdna xdp_core xrt_coreutil)
    target_link_libraries(xdp_aie_trace_plugin_xdna PRIVATE xdp_core xrt_coreutil xaiengine)
    target_compile_definitions(xdp_aie_trace_plugin_xdna PRIVATE XDP_VE2_BUILD=1 FAL_LINUX="on")
    target_include_directories(xdp_aie_trace_plugin_xdna PRIVATE ${CMAKE_SOURCE_DIR}/src)
    set_target_properties(xdp_aie_trace_plugin_xdna PROPERTIES VERSION ${XRT_VERSION_STRING} SOVERSION ${XRT_SOVERSION})

    install (TARGETS xdp_aie_trace_plugin_xdna
      RUNTIME DESTINATION ${XDP_PLUGIN_INSTALL_DIR} COMPONENT ${XRT_COMPONENT}
      LIBRARY DESTINATION ${XDP_PLUGIN_INSTALL_DIR} COMPONENT ${XRT_COMPONENT} ${XRT_NAMELINK_SKIP}
    )
  endif()
    
  if (DEFINED XRT_AIE_BUILD AND XRT_EDGE)
    set(IMPL_DIR "${PROFILE_DIR}/plugin/aie_trace/edge")
    set(OFFLOAD_DIR "${PROFILE_DIR}/device/aie_trace")
    set(DEVICE_DIR "${PROFILE_DIR}/device/hal_device")

    file(GLOB AIE_TRACE_COMPONENT_FILES
      "${OFFLOAD_DIR}/*.h"
      "${OFFLOAD_DIR}/*.cpp"
      "${DEVICE_DIR}/*.h"
      "${DEVICE_DIR}/*.cpp"
      "${IMPL_DIR}/*.h"
      "${IMPL_DIR}/*.cpp"
    )

    add_library(xdp_aie_trace_plugin SHARED ${AIE_TRACE_PLUGIN_FILES} ${AIE_TRACE_COMPONENT_FILES} ${AIE_TRACE_UTIL_FILES} ${AIE_TRACE_CONFIG_FILES})
    add_dependencies(xdp_aie_trace_plugin xdp_core xrt_coreutil)
    target_link_libraries(xdp_aie_trace_plugin PRIVATE xdp_core xrt_coreutil xaiengine)
    if (XDP_VE2_BUILD_CMAKE STREQUAL "yes")
      target_compile_definitions(xdp_aie_trace_plugin PRIVATE XDP_VE2_ZOCL_BUILD=1 FAL_LINUX="on")
    else()
      target_compile_definitions(xdp_aie_trace_plugin PRIVATE FAL_LINUX="on")
    endif()
    set_target_properties(xdp_aie_trace_plugin PROPERTIES VERSION ${XRT_VERSION_STRING} SOVERSION ${XRT_SOVERSION})

    install (TARGETS xdp_aie_trace_plugin
      RUNTIME DESTINATION ${XDP_PLUGIN_INSTALL_DIR} COMPONENT ${XRT_COMPONENT}
      LIBRARY DESTINATION ${XDP_PLUGIN_INSTALL_DIR} COMPONENT ${XRT_COMPONENT} ${XRT_NAMELINK_SKIP}
    )
  endif()

# Else, on edge-aarch64 don't build at all

endif()

=== debian/changelog ===
xrt (1:2.21.70-4) unstable; urgency=medium

  * Transition alveo libries for swemu and noop (Closes: #1125292)

 -- Mario Limonciello <superm1@debian.org>  Mon, 12 Jan 2026 09:22:08 -0600

xrt (1:2.21.70-3) unstable; urgency=medium

  * Only install swemu and noop on amd64

 -- Mario Limonciello <superm1@gmail.com>  Sun, 11 Jan 2026 13:38:42 -0600

xrt (1:2.21.70-2) unstable; urgency=medium

  * d/libxrt-dev.install: Add missing static libraries
    (Closes: #1124034)
  * d/control: Add libxrt-npu2, libxrt-alveo2, and python3-xrt to
    libxrt-dev deps

 -- Mario Limonciello <superm1@debian.org>  Sun, 04 Jan 2026 12:56:12 -0600

xrt (1:2.21.70-1) unstable; urgency=medium

  * New upstream version.  Fixes some launch issues for xrt-smi.
  * Add autopkgtest to try to ensure xrt-smi can be launched

 -- Mario Limonciello <superm1@debian.org>  Wed, 17 Dec 2025 11:28:51 -0600

=== debian/control ===
Source: xrt
Section: libs
Priority: optional
Maintainer: Debian Xilinx Package Maintainers <team+pkg-xilinx@tracker.debian.org>
Uploaders: Punit Agrawal <punit@debian.org>,
	   Nobuhiro Iwamatsu <iwamatsu@debian.org>,
	   Mario Limonciello <superm1@debian.org>,
Build-Depends: cmake,
	debhelper-compat (= 13),
	appstream,
	bash-completion,
	dh-dkms,
	dh-python,
	doxygen [amd64],
	git,
	libboost-filesystem-dev,
	libboost-program-options-dev,
	libboost-system-dev,
	libcurl4-openssl-dev,
	libdrm-dev,
	libncurses-dev,
	libprotobuf-dev,
	libssl-dev,
	libudev-dev,
	libyaml-dev,
	lsb-release [amd64],
	ocl-icd-opencl-dev,
	ocl-icd-dev,
	pkgconf,
	protobuf-compiler,
	pybind11-dev,
	python3-dev,
	rapidjson-dev,
	systemtap-sdt-dev,
	uuid-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-dkms
Homepage: https://www.xilinx.com/products/design-tools/vitis/xrt.html
Vcs-Git: https://salsa.debian.org/xilinx-packages-team/xrt.git
Vcs-Browser: https://salsa.debian.org/xilinx-packages-team/xrt

Package: libxrt2
Architecture: arm64 amd64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libxrt1 (<< ${binary:Version}),
        libxrt-alveo2 (<< 1:2.21.70-3)
Conflicts: libxrt1
Replaces: libxrt1
Description: Xilinx Runtime (XRT) - runtime libraries
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides the runtime environment for xrt.

Package: libxrt-npu2
Architecture: arm64 amd64
Multi-Arch: same
Depends: ${misc:Depends},
	 ${shlibs:Depends},
Breaks: libxrt2 (<< 202520.2.20.172-1)
Description: Xilinx Runtime (XRT) - runtime libraries
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides the runtime environment for XRT NPU.

Package: libxrt-alveo2
Architecture: arm64 amd64
Multi-Arch: same
Depends: ${misc:Depends},
	 ${shlibs:Depends},
Breaks: libxrt2 (<< 1:2.21.70-3)
Replaces: libxrt2 (<< 1:2.21.70-3)
Description: Xilinx Runtime (XRT) - runtime libraries
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides the runtime environment for XRT Alveo.

Package: python3-xrt
Architecture: arm64 amd64
Section: python
Depends: ${misc:Depends},
	 ${shlibs:Depends},
	 ${python3:Depends},
	 libxrt2 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - Python bindings
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides Python bindings for XRT.

Package: libxrt-dev
Architecture: arm64 amd64
Section: libdevel
Multi-Arch: same
Depends: ${misc:Depends},
	 ${shlibs:Depends},
	 python3-xrt (= ${binary:Version}),
	 libxrt2 (= ${binary:Version}),
	 libxrt-npu2 (= ${binary:Version}),
	 libxrt-alveo2 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - development files
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides the development environment for xrt.

Package: libxrt-utils
Architecture: arm64 amd64
Section: utils
Depends: ${misc:Depends},
	 ${shlibs:Depends},
	 python3,
Description: Xilinx Runtime (XRT) - runtime -- utilities
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package contains utilities from the xrt project.

Package: libxrt-utils-npu
Architecture: arm64 amd64
Section: utils
Depends: ${misc:Depends},
	 ${shlibs:Depends},
	 libxrt-utils,
	 libxrt-npu2 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - runtime -- utilities
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package contains a utilities from the XRT NPU project.

Package: libxrt-utils-alveo
Architecture: arm64 amd64
Section: utils
Depends: ${misc:Depends},
	 ${shlibs:Depends},
	 libxrt-utils,
	 libxrt-alveo2 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - runtime -- utilities
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package contains a utilities from the XRT Alveo project.

Package: xrt-xocl-dkms
Architecture: amd64
Depends: ${misc:Depends},
	 ${shlibs:Depends},
	 dkms
Description: Xilinx Runtime (XRT) - runtime -- utilities
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package contains the XOCL DKMS kernel drivers.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

BUILDDIR := obj-$(shell dpkg-architecture -q DEB_HOST_GNU_TYPE)

CONFIGURE_ARGS = -DCMAKE_BUILD_TYPE=Release -DXRT_NPU=1 -DXRT_ALVEO=1 -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON

%:
	dh $@ --with bash-completion --with python3 --sourcedir=.

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_ARGS)

override_dh_auto_install:
	dh_auto_install

	# Alveo HW emulation only for amd64
	if [ "$(DEB_HOST_ARCH)" = "amd64" ] ; then \
	  mkdir -p debian/libxrt-alveo2/usr/lib/$(DEB_HOST_GNU_TYPE); \
	  mv debian/tmp/usr/lib/$(DEB_HOST_GNU_TYPE)/libxrt_hwemu*.so.* debian/libxrt-alveo2/usr/lib/$(DEB_HOST_GNU_TYPE); \
	  mv debian/tmp/usr/lib/$(DEB_HOST_GNU_TYPE)/libxrt_swemu*.so.* debian/libxrt-alveo2/usr/lib/$(DEB_HOST_GNU_TYPE); \
	  mv debian/tmp/usr/lib/$(DEB_HOST_GNU_TYPE)/libxrt_noop.so.* debian/libxrt-alveo2/usr/lib/$(DEB_HOST_GNU_TYPE); \
	fi

	# udev rules
	mkdir -p debian/xrt-xocl-dkms/usr/lib/udev/rules.d
	install -m 644 xrt/XRT/src/runtime_src/core/pcie/driver/linux/xocl/mgmtpf/99-xclmgmt.rules debian/xrt-xocl-dkms/usr/lib/udev/rules.d
	install -m 644 xrt/XRT/src/runtime_src/core/pcie/driver/linux/xocl/userpf/99-xocl.rules debian/xrt-xocl-dkms/usr/lib/udev/rules.d
	# dkms postinst/prerm hooks
	dh_dkms -pxrt-xocl-dkms -- $(BUILDDIR)/xrt/XRT/src/dkms.conf
	# Overwrite xbtop wrapper script
	mv debian/tmp/usr/python/xbtop.py debian/tmp/usr/bin/xbtop

override_dh_auto_test:
	make -C $(BUILDDIR) install DESTDIR=`pwd`/$(BUILDDIR) # xrt-smi and xbmgmt tests require install
	dh_auto_test
